import java.io.*;
import java.lang.*;
import java.awt.*;
import java.util.Random;

class tpcsp1 {
	public static void main(String args[]) {
	System.out.println( "priorit max: "+Thread.MAX_PRIORITY+"priorit min: "+Thread.MIN_PRIORITY);
	try {
		String procNames[]={"P1","P2","P3","P4","P5"};
		Proc [] proc=new Proc[5];
		Record record=new Record();
		for(int i=0;i<5;i++) proc[i]=new Proc(procNames[i],record,i+1);
		for(int i=0;i<5;i++) proc[i].start();
		for(int i=0;i<4;i++) proc[i].join();
		proc[4].stop();
		System.out.print("MAIN: ");
		for (int i=0;i<5;i++)
			System.out.print(" r.c["+i+"]="+record.c[i]);
		long somme=record.c[0]+record.c[1]+record.c[2]+record.c[3]	
		+record.c[4];
		System.out.println("  total: "+somme);
	      } catch(Exception e) {
			System.out.println(e.toString());
	 	}
	}
}

class Record {
		long c[]={20,20,20,20,20};
}

class Proc extends Thread {
		Record r;
		int numproc; long somme=0;
		Random rnd=new Random();
		Proc(String nom,Record leRecord,int num) {
			super (nom);
			r=leRecord; numproc=num;
			System.out.println(nom+" "+getName()+"  priorit: "
			+getPriority());
		}
	public void run() {
		if (numproc==5) {
			while(true) {
				try {
					sleep(1);
					somme=r.c[0]+r.c[1]+r.c[2]+r.c[3]+r.c[4];
					if (somme!=100){
						System.out.print("AFF:  ");
						for(int i=0;i<5;i++) 
							System.out.print(" r.c["+i+"]="
							+r.c[i]);
						System.out.println("  total: "+somme);
				}
			} catch(InterruptedException e) {
			System.out.println(e.getMessage());
			}
		}
	} else {
		try {
			for(int m=0;m<5000;m++) {
				long copie;
				sleep(1);
				int pos=rnd.nextInt()%5;
				pos=(pos<0)?-pos:pos;
					for(int k=0;k<5;k++) {
					if(k!=pos) r.c[k]=r.c[k]+1;
					else r.c[k]=r.c[k]-4;
				}
			}
			System.out.println(getName()+" termin");
		} catch(InterruptedException e) {
			System.out.println(e.getMessage());
			}
	}
}
}	
				



	
